using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Practices.EnterpriseLibrary.Configuration.Design;
using EnterpriseLibraryExtensions.ConfigurationConstsWriter.Properties;

namespace EnterpriseLibraryExtensions.ConfigurationConstsWriter
{
    public class ConfigurationConstsCommandRegistrar : CommandRegistrar
    {
        public ConfigurationConstsCommandRegistrar(IServiceProvider serviceProvider)
            :base(serviceProvider)
        {
        }

        public override void Register()
        {
            base.AddSingleChildNodeCommand(Resources.AddConfigurationConstsWriterNode,
                Resources.AddConfigurationConstsWriterNodeLong, typeof(ConfigurationConstsWriterNode),
                typeof(ConfigurationApplicationNode));

            base.AddDefaultCommands(typeof(ConfigurationConstsWriterNode));
        }

        public static void Register(IServiceProvider serviceProvider)
        {
            new ConfigurationConstsCommandRegistrar(serviceProvider).Register();
        }
    }
}
