using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Practices.EnterpriseLibrary.Configuration.Design;

namespace EnterpriseLibraryExtensions.ConfigurationConstsWriter
{
    public class ConfigurationConstsWriterNodeBuilder : NodeBuilder
    {
        public ConfigurationConstsWriterNodeBuilder(IServiceProvider serviceProvider)
            :base(serviceProvider)
        {
        }

        public ConfigurationConstsWriterNode Build(ConfigurationConstsWriterSettings settings)
        {
            ConfigurationConstsWriterNode constsWriterNode = new ConfigurationConstsWriterNode(settings);

            IExtenderStorageService extenderStorageService = (IExtenderStorageService) ServiceProvider.GetService(typeof(IExtenderStorageService));
            extenderStorageService.Load<string>(constsWriterNode, ConfigurationConstsWriterNode.ConstantNameProperty, ServiceHelper.GetUIHierarchyService(ServiceProvider).SelectedHierarchy, settings.ConstantNameByNodePath, null);

            return constsWriterNode;
        }

        public static ConfigurationConstsWriterNode Build(IServiceProvider serviceProvider, ConfigurationConstsWriterSettings settings)
        {
            return new ConfigurationConstsWriterNodeBuilder(serviceProvider).Build(settings);
        }
    }
}
