using System;
using System.Text;
using System.Configuration;

namespace EnterpriseLibraryExtensions.ConfigurationConstsWriter
{
    public class ConfigurationConstsWriterSettings : ConfigurationSection
    {
        public const string SectionName = "enterpriseLibraryExtensions.ConfigurationConstsWriter";

        private const string NameProperty = "name";
        private const string NamespaceProperty = "namespace";
        private const string ClassProperty = "class";
        private const string FilePathProperty = "filePath";
        private const string CodingLanguageProperty = "codingLanguage";
        private const string ConstantNameByNodePathProperty = "constantNameByNodePath";

        [ConfigurationProperty(NameProperty, DefaultValue="Configuration Constants Writer")]
        public string Name
        {
            get { return (string)base[NameProperty]; }
            set { base[NameProperty] = value; }
        }

        [ConfigurationProperty(NamespaceProperty, DefaultValue = "ConfigurationConstants")]
        public string Namespace
        {
            get { return (string)base[NamespaceProperty]; }
            set { base[NamespaceProperty] = value; }
        }

        [ConfigurationProperty(ClassProperty, DefaultValue = "EnterpriseLibraryConfiguration")]
        public string Class
        {
            get { return (string)base[ClassProperty]; }
            set { base[ClassProperty] = value; }
        }

        [ConfigurationProperty(FilePathProperty, DefaultValue = "ConfigurationConstants.cs")]
        public string FilePath
        {
            get { return (string)base[FilePathProperty]; }
            set { base[FilePathProperty] = value; }
        }

        [ConfigurationProperty(CodingLanguageProperty, DefaultValue = CodingLanguage.CSharp)]
        public CodingLanguage CodingLanguage
        {
            get { return (CodingLanguage)base[CodingLanguageProperty]; }
            set { base[CodingLanguageProperty] = value; }
        }

        [ConfigurationProperty(ConstantNameByNodePathProperty)]
        public KeyValueConfigurationCollection ConstantNameByNodePath
        {
            get { return (KeyValueConfigurationCollection)base[ConstantNameByNodePathProperty]; }
            set { base[ConstantNameByNodePathProperty] = value; }
        }

    }
}
