using System;
using System.Collections.Generic;
using System.Text;
using System.Configuration;

namespace EnterpriseLibraryExtensions.ConfigurationConstsWriter
{
    class ConfigurationConstsWriterSettingsBuilder
    {
        IServiceProvider _serviceProvider;

        public ConfigurationConstsWriterSettingsBuilder(IServiceProvider serviceProvider)
        {
            _serviceProvider = serviceProvider;
        }

        public ConfigurationConstsWriterSettings Build(ConfigurationConstsWriterNode node)
        {
            ConfigurationConstsWriterSettings settings = new ConfigurationConstsWriterSettings();
            settings.Class = node.ClassName;
            settings.CodingLanguage = node.CodingLanguage;
            settings.Name = node.Name;
            settings.Namespace = node.NamespaceName;
            settings.FilePath = node.FilePath;

            IExtenderStorageService extenderStorageService = (IExtenderStorageService) _serviceProvider.GetService(typeof(IExtenderStorageService));
            settings.ConstantNameByNodePath = extenderStorageService.Save<string>(node, ConfigurationConstsWriterNode.ConstantNameProperty, null);

            return settings;
        }

        public static ConfigurationConstsWriterSettings Build(IServiceProvider serviceProvider, ConfigurationConstsWriterNode node)
        {
            return new ConfigurationConstsWriterSettingsBuilder(serviceProvider).Build(node);
        }
    }
}
