using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Practices.EnterpriseLibrary.Configuration.Design;
using EnterpriseLibraryExtensions.EnvironmentalOverrides.Properties;

namespace EnterpriseLibraryExtensions.EnvironmentalOverrides
{
    class EnvironmentalOverridesCommandRegistrar : CommandRegistrar
    {
        public EnvironmentalOverridesCommandRegistrar(IServiceProvider serviceProvider)
            :base(serviceProvider)
        {
        }

        public override void Register()
        {
            AddChildNodeCommand addEnvironmentalOverridesCommand = new AddChildNodeCommand(ServiceProvider, typeof(EnvironmentalOverridesNode));
            addEnvironmentalOverridesCommand.Executed += delegate(object sender, EventArgs e)
            {
                addEnvironmentalOverridesCommand.ChildNode.AddNode(new EnvironmentNode("Production Environment", "Production Environment"));
            };

            AddUICommand(new ConfigurationUICommand(ServiceProvider, 
                Resources.EnvironmentalOverridesNode, 
                string.Format("Add {0} node.", Resources.EnvironmentalOverridesNode), CommandState.Enabled, NodeMultiplicity.Disallow, addEnvironmentalOverridesCommand, typeof(EnvironmentalOverridesNode), 0, InsertionPoint.New, null), typeof(ConfigurationApplicationNode));
            AddDefaultCommands(typeof(EnvironmentalOverridesNode));


            AddMultipleChildNodeCommand(Resources.EnvrionmentNode,
                string.Format("Add {0} node.", Resources.EnvrionmentNode), 
                typeof(EnvironmentNode), typeof(EnvironmentalOverridesNode));
            AddDefaultCommands(typeof(EnvironmentNode));

        }


        public static void Register(IServiceProvider serviceProvider)
        {
            new EnvironmentalOverridesCommandRegistrar(serviceProvider).Register();
        }
    }
}
