using System;
using System.Collections.Generic;
using System.Text;
using System.ComponentModel;
using System.Globalization;

namespace EnterpriseLibraryExtensions.NakedNode
{
    public class CultureInfoStringConverter : StringConverter
    {
        public override object ConvertFrom(ITypeDescriptorContext context, CultureInfo culture, object value)
        {
            if (value is CultureInfo)
            {
                return ((CultureInfo)value).Name;
            }
            throw new NotSupportedException();
        }

        public override object ConvertTo(ITypeDescriptorContext context, CultureInfo culture, object value, Type destinationType)
        {
            if (value is string && destinationType == typeof(CultureInfo))
            {
                try
                {
                    return new CultureInfo((string)value);
                }
                catch
                {
                    return null;
                }
            }
            throw new NotSupportedException();
        }

        public override bool CanConvertFrom(ITypeDescriptorContext context, Type sourceType)
        {
            return typeof(CultureInfo).IsAssignableFrom(sourceType);
        }
        
    }
}
