using System;
using System.Collections.Generic;
using System.Text;
using System.ComponentModel;

namespace EnterpriseLibraryExtensions.NakedNode
{
    class EncodingTypeConverter : TypeConverter
    {
        public override bool GetStandardValuesSupported(ITypeDescriptorContext context)
        {
            return true;
        }
        public override StandardValuesCollection GetStandardValues(ITypeDescriptorContext context)
        {
            List<Encoding> stdValues = new List<Encoding>();
            stdValues.Add(Encoding.ASCII);
            stdValues.Add(Encoding.Unicode);
            stdValues.Add(Encoding.UTF32);
            stdValues.Add(Encoding.UTF7);
            stdValues.Add(Encoding.UTF8);

            if (!stdValues.Contains(Encoding.Default))
            {
                stdValues.Add(Encoding.Default);
            }

            return new StandardValuesCollection(stdValues.ToArray());
        }

        public override bool GetStandardValuesExclusive(ITypeDescriptorContext context)
        {
            return false;
        }

        public override bool CanConvertFrom(ITypeDescriptorContext context, Type sourceType)
        {
            return (sourceType == typeof(string));
        }

        public override bool CanConvertTo(ITypeDescriptorContext context, Type destinationType)
        {
            return (destinationType == typeof(Encoding));
        }

        public override object ConvertFrom(ITypeDescriptorContext context, System.Globalization.CultureInfo culture, object value)
        {
            string a = (string)value;
            if (a == null || a.Length == 0) return Encoding.Default;

            Encoding e = Encoding.GetEncoding(a);

            return e;
        }

        public override object ConvertTo(ITypeDescriptorContext context, System.Globalization.CultureInfo culture, object value, Type destinationType)
        {
            if (destinationType == typeof(string))
            {
                Encoding t = (Encoding)value;
                return t.BodyName;
            }
            else if (destinationType == typeof(Encoding))
            {
                return value;
            }

            return null;
        }
    }
    
}
