using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Practices.EnterpriseLibrary.Configuration.Design;

namespace EnterpriseLibraryExtensions.NakedNode
{
    public class StringTypeSelectorEditor : TypeSelectorEditor
    {
        public override object EditValue(System.ComponentModel.ITypeDescriptorContext context, IServiceProvider provider, object value)
        {
            DefaultAssemblyStringAttribute asmStringAttribute = context.PropertyDescriptor.Attributes[typeof(DefaultAssemblyStringAttribute)] as DefaultAssemblyStringAttribute;
            string typeString = (value == null) ? null : value.ToString();
            if (asmStringAttribute != null)
            {
                typeString = asmStringAttribute.FixTypeString(typeString);
            }
            Type currentType = (value == null) ? null : Type.GetType(typeString);

            Type newType = (Type)base.EditValue(context, provider, currentType);
            if (newType == null) return null;
            return newType.AssemblyQualifiedName;
        }
    }
}
