using System;
using System.Collections.Generic;
using System.Text;
using System.ComponentModel;

namespace EnterpriseLibraryExtensions.NakedNode
{
    public class TypeConverterService : Dictionary<Type, TypeConverter>, ITypeConverterService
    {
        public TypeConverterService()
        {
            Add(typeof(TimeSpan), new TimeSpanTypeConverter());
            Add(typeof(Encoding), new EncodingTypeConverter());
        }
        public TypeConverter GetTypeConverterForType(Type type)
        {
            if (ContainsKey(type))
            {
                return base[type];
            } 
            return null;
        }
    }

    public interface ITypeConverterService
    {
        TypeConverter GetTypeConverterForType(Type type);
    }
}
