using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing.Design;
using Microsoft.Practices.EnterpriseLibrary.Configuration.Design;


namespace EnterpriseLibraryExtensions.NakedNode
{
    public class TypeEditorService : Dictionary<Type, UITypeEditor>, ITypeEditorService
    {
        public TypeEditorService()
        {
            Add(typeof(Type), new TypeSelectorEditor());
            Add(typeof(Password), new PasswordEditor());
        }

        #region ITypeEditorService Members

        public UITypeEditor GetEditor(Type propertyType)
        {
            if (ContainsKey(propertyType))
            {
                return this[propertyType];
            }

            return null;
        }

        #endregion
    }

    public interface ITypeEditorService
    {
        UITypeEditor GetEditor(Type propertyType);
    }
}
