using System;
using System.Collections.Generic;
using System.Text;
using System.Configuration;
using System.Reflection;

namespace EnterpriseLibraryExtensions.NakedNode
{
    public static class Utility
    {

        public static List<ConfigurationPropertyAttribute> GetConfigurationProperties(Type t)
        {
            List<ConfigurationPropertyAttribute> result = new List<ConfigurationPropertyAttribute>();
            foreach (PropertyInfo property in t.GetProperties())
            {
                if (property.IsDefined(typeof(ConfigurationPropertyAttribute), true))
                {
                    ConfigurationPropertyAttribute configProperty = property.GetCustomAttributes(typeof(ConfigurationPropertyAttribute), true)[0] as ConfigurationPropertyAttribute;
                    if (configProperty != null)
                    {
                        result.Add(configProperty);
                    }
                }
            }

            return result;
        }

        internal static Dictionary<string, string> GetConfigurationPropertyNameMap(Type type)
        {
            Dictionary<string, string> nameMap = new Dictionary<string, string>();

            foreach (PropertyInfo property in type.GetProperties())
            {
                if (property.IsDefined(typeof(ConfigurationPropertyAttribute), true))
                {
                    ConfigurationPropertyAttribute configProperty = property.GetCustomAttributes(typeof(ConfigurationPropertyAttribute), true)[0] as ConfigurationPropertyAttribute;
                    if (configProperty != null)
                    {
                        nameMap.Add(property.Name, configProperty.Name);
                    }
                }
            }

            return nameMap;
        }
    }
}
