using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using EnterpriseLibraryExtensions.PasswordParameter.Properties;

namespace EnterpriseLibraryExtensions.PasswordParameter
{
    public partial class PasswordEditorUI : Form
    {
        public PasswordEditorUI()
        {
            InitializeComponent();
        }

        public string Password
        {
            get { return passwordTextBox.Text; }
        }

        protected override void OnLoad(EventArgs e)
        {
            base.OnLoad(e);
            passwordTextBox.Select();
        }

        private void OnOkButtonClick(object sender, EventArgs e)
        {
            if (passwordTextBox.Text == confirmPasswordTextBox.Text)
            {
                this.DialogResult = DialogResult.OK;
                this.Close();
            }
            else
            {
                MessageBox.Show(Resources.MismatchedPasswordMessage, Resources.MismatchedPasswordCaption, MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                passwordTextBox.Clear();
                confirmPasswordTextBox.Clear();
                passwordTextBox.Select();
            }
        }

        private void OnCancelButtonClick(object sender, EventArgs e)
        {
            this.DialogResult = DialogResult.Cancel;
            this.Close();
        }
    }
}