using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Practices.EnterpriseLibrary.Configuration.Design;
using System.ComponentModel;
using System.Drawing.Design;
using EnterpriseLibraryExtensions.PasswordParameter.Properties;
using Microsoft.Practices.EnterpriseLibrary.Configuration.Design.Validation;

namespace EnterpriseLibraryExtensions.PasswordParameter
{
    [Image(typeof(PasswordParameterNode))]
    [SelectedImage(typeof(PasswordParameterNode))]
    [NodeInformation(typeof(PasswordParameterNode), "PasswordParameterNodeInfoHtml", "PasswordParameterNodeInfoTitle", typeof(Resources))]
    public class PasswordParameterNode : ConfigurationNode
    {
        public const string PasswordNodeName = "Password";

        Password _value = null;

        public PasswordParameterNode()
        {
        }

        public PasswordParameterNode(string value)
        {
            _value = new Password(value);
        }

        [Editor(typeof(PasswordEditor), typeof(UITypeEditor))]
        [SRDescription("PasswordProperty", typeof(Resources))]
        [SRCategory("General", typeof(Resources))]
        [Required]
        public Password Value
        {
            get { return _value; }
            set { _value = value; }
        }

        [ReadOnly(true)]
        public override string Name
        {
            get
            {
                return PasswordNodeName;   
            }
        }
    }
}
