using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Practices.EnterpriseLibrary.Configuration.Design;
using EnterpriseLibraryExtensions.Protection.Properties;
//using Microsoft.Practices.EnterpriseLibrary.Data.Configuration.Design;

namespace EnterpriseLibraryExtensions.Protection
{
    class ProtectionCommandRegistrar : CommandRegistrar
    {
        public ProtectionCommandRegistrar(IServiceProvider serviceProvider)
            :base(serviceProvider)
        {
        }

        public override void Register()
        {
            base.AddSingleChildNodeCommand(Resources.AddProtector, Resources.AddProtectorLong, typeof(ProtectionNode), typeof(ConfigurationApplicationNode));
            base.AddDefaultCommands(typeof(ProtectionNode));
        }

        public static void Register(IServiceProvider serviceProvider)
        {
            new ProtectionCommandRegistrar(serviceProvider).Register();
        }
    }
}
