using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Practices.EnterpriseLibrary.Configuration.Design;

namespace EnterpriseLibraryExtensions.Protection
{
    class ProtectionNodeBuilder : NodeBuilder
    {
        IExtenderStorageService _extendedStorageService;
        IConfigurationUIHierarchy _uiHierarchy;

        public ProtectionNodeBuilder(IServiceProvider serviceProvider, IConfigurationUIHierarchy uiHierarchy)
            : base(serviceProvider)
        {
            _uiHierarchy = uiHierarchy;
            _extendedStorageService = (IExtenderStorageService)serviceProvider.GetService(typeof(IExtenderStorageService));
        }

        public ProtectionNode Build(ProtectionSettings settings)
        {
            ProtectionNode node = new ProtectionNode(settings);
            _extendedStorageService.Load<string>(node, ProtectionNode.ProtectProperty, _uiHierarchy, settings.ProtectedSectionByPath, null);

            return node;
        }

        public static ProtectionNode Build(IServiceProvider serviceProvider, IConfigurationUIHierarchy uiHierarchy, ProtectionSettings settings)
        {
            return new ProtectionNodeBuilder(serviceProvider, uiHierarchy).Build(settings);
        }
    }
}
