using System;
using System.Collections.Generic;
using System.Text;
using System.Configuration;

namespace EnterpriseLibraryExtensions.Protection
{
    public class ProtectionSettings : ConfigurationSection
    {
        public const string SectionName = "enterpriseLibraryExtensions.Protection";

        private const string NameProperty = "name";
        private const string ProtectedSectionByPathProperty = "ProtectedSectionByPath";
        private const string ProtectionProviderProperty = "protectionProvider";

        [ConfigurationProperty(NameProperty, DefaultValue="Configuration Protector")]
        public string Name
        {
            get { return (string) base[NameProperty]; }
            set { base[NameProperty] = value; }
        }

        [ConfigurationProperty(ProtectionProviderProperty)]
        public string ProtectionProvider
        {
            get { return (string)base[ProtectionProviderProperty]; }
            set { base[ProtectionProviderProperty] = value; }
        }

        [ConfigurationProperty(ProtectedSectionByPathProperty)]
        public KeyValueConfigurationCollection ProtectedSectionByPath
        {
            get { return (KeyValueConfigurationCollection)base[ProtectedSectionByPathProperty]; }
            set { base[ProtectedSectionByPathProperty] = value; }
        }
    }
}
