using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Practices.EnterpriseLibrary.Configuration.Design;

namespace EnterpriseLibraryExtensions.Protection
{
    class ProtectionSettingsBuilder
    {
        IExtenderStorageService _extendedStorageService;

        public ProtectionSettingsBuilder(IServiceProvider serviceProvider)
        {
            _extendedStorageService = (IExtenderStorageService) serviceProvider.GetService(typeof(IExtenderStorageService));
        }

        public ProtectionSettings Build(ProtectionNode node)
        {
            ProtectionSettings settings = new ProtectionSettings();
            settings.ProtectionProvider = node.ProtectionProvider;
            settings.Name = node.Name;
            settings.ProtectedSectionByPath = _extendedStorageService.Save<string>(node, ProtectionNode.ProtectProperty, null);

            return settings;
        }

        public static ProtectionSettings Build(IServiceProvider serviceProvider, ProtectionNode node)
        {
            return new ProtectionSettingsBuilder(serviceProvider).Build(node);
        }
    }
}
