using System;
using System.Collections.Generic;
using System.Text;
using EnterpriseLibraryExtensions.NakedNode;
using System.Web.Configuration;
using Microsoft.Practices.EnterpriseLibrary.Configuration.Design;
using System.ComponentModel;

namespace EnterpriseLibraryExtensions.SystemWeb
{
    [SelectedImage(typeof(AssemblyCollectionNode))]
    [Image(typeof(AssemblyCollectionNode))]
    public class AssemblyCollectionNode : NakedConfigurationNodeCollection<AssemblyCollection, AssemblyCollectionNode.RWAssembly>
    {
        public AssemblyCollectionNode()
        {
        }

        public AssemblyCollectionNode(AssemblyCollection data)
            : base(data, data.EmitClear, false)
        {
            foreach (AssemblyInfo ai in data)
            {
                AddCollectionItem(new RWAssembly(ai));
            }
        }

        public override void CopyTo(object target)
        {
            AssemblyCollection assemblyCollection = target as AssemblyCollection;

            if (assemblyCollection != null)
            {
                assemblyCollection.Clear();
                foreach (RWAssembly asm in Collection)
                {
                    assemblyCollection.Add(asm.CreateElement());
                }
                assemblyCollection.EmitClear = EmitClear;
            }
        }

        public class RWAssembly : CollectionItem<AssemblyInfo>
        {
            public RWAssembly()
            {
            }

            public RWAssembly(AssemblyInfo asm)
                : base(asm)
            {
            }

            public override AssemblyInfo CreateElement()
            {
                return new AssemblyInfo((string)base["assembly"]);
            }
        }
    }
}

