using System;
using System.Collections.Generic;
using System.Text;
using EnterpriseLibraryExtensions.NakedNode;
using System.Web.Configuration;
using System.ComponentModel;
using Microsoft.Practices.EnterpriseLibrary.Configuration.Design;

namespace EnterpriseLibraryExtensions.SystemWeb
{
    [Image(typeof(AuthenticationSectionNode))]
    [SelectedImage(typeof(AuthenticationSectionNode))]
    public class AuthenticationSectionNode : NakedConfigurationNode<AuthenticationSection>
    {
        public AuthenticationSectionNode()
            : this(new AuthenticationSection())
        {
        }

        public AuthenticationSectionNode(AuthenticationSection data)
            :base(data)
        {
        }

        protected override void InitializeProperties(IPropertyAttributeService propertyAttributeService)
        {
            base.InitializeProperties(propertyAttributeService);

            
            propertyAttributeService.SetDefaultAttributes(typeof(FormsAuthenticationConfiguration));
            propertyAttributeService.SetDefaultAttributes(typeof(PassportAuthentication));

            propertyAttributeService.AddAttributeForAllProperties(typeof(FormsAuthenticationConfiguration), new CategoryAttribute("Forms authentication"));
            propertyAttributeService.AddAttributeForAllProperties(typeof(PassportAuthentication), new CategoryAttribute("Passport authentication"));
        }

        protected override void AddUnionedObjects()
        {
            AddUnionedObject("forms", TheObject.Forms);
            AddUnionedObject("passport", TheObject.Passport);
        }

        protected override void InitializeCommands(NakedNodeCommandRegistrar commandRegistrar)
        {
            commandRegistrar.RegisterDefaultChildCommands(typeof(FormsAuthenticationConfiguration));
            commandRegistrar.RegisterDefaultChildCommands(typeof(PassportAuthentication));
        }
    }
}
