using System;
using System.Collections.Generic;
using System.Text;
using EnterpriseLibraryExtensions.NakedNode;
using System.Web.Configuration;
using Microsoft.Practices.EnterpriseLibrary.Configuration.Design;
using System.ComponentModel;

namespace EnterpriseLibraryExtensions.SystemWeb
{
    [SelectedImage(typeof(ClientTargetSectionNode))]
    [Image(typeof(ClientTargetSectionNode))]
    public class ClientTargetSectionNode : NakedConfigurationNodeCollection<ClientTargetSection, ClientTargetSectionNode.RWClientTarget>
    {
        public ClientTargetSectionNode()
        {
        }

        public ClientTargetSectionNode(ClientTargetSection data)
            : base(data, data.ClientTargets.EmitClear, false)
        {
            foreach (ClientTarget ct in data.ClientTargets)
            {
                AddCollectionItem(new RWClientTarget(ct));
            }
        }

        public override void CopyTo(object target)
        {
            ClientTargetSection clientTargetSection = target as ClientTargetSection;

            if (clientTargetSection != null)
            {
                clientTargetSection.ClientTargets.Clear();
                foreach (RWClientTarget clientTarget in Collection)
                {
                    clientTargetSection.ClientTargets.Add(clientTarget.CreateElement());
                }
                clientTargetSection.ClientTargets.EmitClear = EmitClear;
            }
        }

        protected override void InitializeCommands(NakedNodeCommandRegistrar commandRegistrar)
        {
        }

        public class RWClientTarget : CollectionItem<ClientTarget>
        {
            public RWClientTarget()
            {
            }

            public RWClientTarget(ClientTarget clientTarget)
                : base(clientTarget)
            {
            }

            public override ClientTarget CreateElement()
            {
                return new ClientTarget((string)base["alias"], (string)base["userAgent"]);
            }
        }
    }
}
