
using System;
using System.Collections.Generic;
using System.Text;
using EnterpriseLibraryExtensions.NakedNode;
using System.Web.Configuration;
using Microsoft.Practices.EnterpriseLibrary.Configuration.Design;
using System.ComponentModel;
using System.Drawing.Design;

namespace EnterpriseLibraryExtensions.SystemWeb
{
    [SelectedImage(typeof(CodeSubDirectoriesCollectionNode))]
    [Image(typeof(CodeSubDirectoriesCollectionNode))]
    public class CodeSubDirectoriesCollectionNode : NakedConfigurationNodeCollection<CodeSubDirectoriesCollection, CodeSubDirectoriesCollectionNode.RWCodeSubDirectory>
    {
        public CodeSubDirectoriesCollectionNode()
        {
        }

        public CodeSubDirectoriesCollectionNode(CodeSubDirectoriesCollection data)
            : base(data, data.EmitClear)
        {
            foreach (CodeSubDirectory csd in data)
            {
                AddCollectionItem(new RWCodeSubDirectory(csd));
            }
        }

        public override void CopyTo(object target)
        {
            CodeSubDirectoriesCollection subDirectories = target as CodeSubDirectoriesCollection;

            if (subDirectories != null)
            {
                subDirectories.Clear();
                foreach (RWCodeSubDirectory subDir in Collection)
                {
                    subDirectories.Add(subDir.CreateElement());
                }
                subDirectories.EmitClear = EmitClear;
            }
        }

        public class RWCodeSubDirectory : CollectionItem<CodeSubDirectory>
        {

            public RWCodeSubDirectory()
            {
            }

            public RWCodeSubDirectory(CodeSubDirectory subDirectory)
                : base(subDirectory)
            {
            }

            public override CodeSubDirectory CreateElement()
            {
                return new CodeSubDirectory((string)base["directoryName"]);
            }
        }
    }
}