using System;
using System.Collections.Generic;
using System.Text;
using EnterpriseLibraryExtensions.NakedNode;
using System.Web.Configuration;
using Microsoft.Practices.EnterpriseLibrary.Configuration.Design;
using System.ComponentModel;
using EnterpriseLibraryExtensions.EnvironmentalOverrides;
using Microsoft.Practices.EnterpriseLibrary.Configuration.Design.Validation;

namespace EnterpriseLibraryExtensions.SystemWeb
{
    [SelectedImage(typeof(FormsAuthenticationCredentialsNode))]
    [Image(typeof(FormsAuthenticationCredentialsNode))]
    public class FormsAuthenticationCredentialsNode : NakedConfigurationNodeCollection<FormsAuthenticationCredentials, FormsAuthenticationCredentialsNode.RWUser>
    {
        public FormsAuthenticationCredentialsNode()
            : this(new FormsAuthenticationCredentials())
        {
        }

        public FormsAuthenticationCredentialsNode(FormsAuthenticationCredentials data)
            : base(data, data.Users.EmitClear, true)
        {

            foreach (FormsAuthenticationUser user in data.Users)
            {
                AddCollectionItem(new RWUser(user));
            }
        }

        protected override void InitializeCommands(NakedNodeCommandRegistrar commandRegistrar)
        {
            
        }

        public override void CopyTo(object target)
        {
            FormsAuthenticationCredentials credentialsElement = target as FormsAuthenticationCredentials;
            if (credentialsElement == null) return;

            credentialsElement.Users.Clear();
            foreach (RWUser user in Collection)
            {
                credentialsElement.Users.Add(user.CreateElement());
            }
            credentialsElement.Users.EmitClear = EmitClear;
        }


        public class RWUser : CollectionItem<FormsAuthenticationUser>
        {
            public RWUser()
                :base()
            {
            }

            public RWUser(FormsAuthenticationUser user)
                : base(user)
            {
            }

            public override FormsAuthenticationUser CreateElement()
            {
                return new FormsAuthenticationUser((string)base["name"], (string)base["password"]);
            }
        }
    }
}
