using System;
using System.Collections.Generic;
using System.Text;
using EnterpriseLibraryExtensions.NakedNode;
using System.Web.Configuration;
using Microsoft.Practices.EnterpriseLibrary.Configuration.Design;
using System.ComponentModel;

namespace EnterpriseLibraryExtensions.SystemWeb
{
    [SelectedImage(typeof(EventMappingCollectionNode))]
    [Image(typeof(EventMappingCollectionNode))]
    public class EventMappingCollectionNode : NakedConfigurationNodeCollection<EventMappingSettingsCollection, EventMappingCollectionNode.RWEventMapping>
    {
        public EventMappingCollectionNode()
        {
        }

        public EventMappingCollectionNode(EventMappingSettingsCollection data)
            : base(data, data.EmitClear)
        {
            foreach (EventMappingSettings eventMapping in data)
            {
                AddCollectionItem(new RWEventMapping(eventMapping));
            }
        }

        public override void Validate(IList<Microsoft.Practices.EnterpriseLibrary.Configuration.Design.Validation.ValidationError> errors)
        {
            //TODO
            base.Validate(errors);
        }


        public override void CopyTo(object target)
        {
            EventMappingSettingsCollection eventMappgins = target as EventMappingSettingsCollection;

            if (eventMappgins != null)
            {
                eventMappgins.Clear();
                foreach (RWEventMapping eventMapping in Collection)
                {
                    eventMappgins.Add(eventMapping.CreateElement());
                }
                eventMappgins.EmitClear = EmitClear;
            }
        }



        public class RWEventMapping : CollectionItem<EventMappingSettings>
        {
            public RWEventMapping()
            {
            }

            public RWEventMapping(EventMappingSettings eventMapping)
                : base(eventMapping)
            {
            }

            public override EventMappingSettings CreateElement()
            {
                return new EventMappingSettings((string)base["name"], (string)base["type"], (int) base["startEventCode"], (int) base["endEventCode"]);
            }
        }
    }
}
