
using System;
using System.Collections.Generic;
using System.Text;
using EnterpriseLibraryExtensions.NakedNode;
using System.Web.Configuration;
using Microsoft.Practices.EnterpriseLibrary.Configuration.Design;
using System.ComponentModel;
using System.Drawing.Design;

namespace EnterpriseLibraryExtensions.SystemWeb
{
    [SelectedImage(typeof(ExpressionBuilderCollectionNode))]
    [Image(typeof(ExpressionBuilderCollectionNode))]
    public class ExpressionBuilderCollectionNode : NakedConfigurationNodeCollection<ExpressionBuilderCollection, ExpressionBuilderCollectionNode.RWExpressionBuilder>
    {
        public ExpressionBuilderCollectionNode()
        {
        }

        public ExpressionBuilderCollectionNode(ExpressionBuilderCollection data)
            : base(data, data.EmitClear)
        {
            foreach(ExpressionBuilder eb in data)
            {
                AddCollectionItem(new RWExpressionBuilder(eb));
            }
        }

        public override void CopyTo(object target)
        {
            ExpressionBuilderCollection expressionBuilders = target as ExpressionBuilderCollection;

            if (expressionBuilders != null)
            {
                expressionBuilders.Clear();
                foreach (RWExpressionBuilder builder in Collection)
                {
                    expressionBuilders.Add(builder.CreateElement());
                }
                expressionBuilders.EmitClear = EmitClear;
            }
        }

        public class RWExpressionBuilder : CollectionItem<ExpressionBuilder>
        {

            public RWExpressionBuilder()
            {
            }

            public RWExpressionBuilder(ExpressionBuilder expressionBuilder)
                : base(expressionBuilder)
            {
            }

            public override ExpressionBuilder CreateElement()
            {
                return new ExpressionBuilder((string)base["expressionPrefix"], (string)base["type"]);
            }
        }
    }
}