using System;
using System.Collections.Generic;
using System.Text;
using System.Web.Configuration;
using EnterpriseLibraryExtensions.NakedNode;
using Microsoft.Practices.EnterpriseLibrary.Configuration.Design;
using System.Globalization;
using System.Web.Compilation;
using System.ComponentModel;
using System.Drawing.Design;

namespace EnterpriseLibraryExtensions.SystemWeb
{
    [SelectedImage(typeof(GlobalizationSectionNode))]
    [Image(typeof(GlobalizationSectionNode))]
    public class GlobalizationSectionNode : NakedConfigurationNode<GlobalizationSection>
    {
        public GlobalizationSectionNode()
            : this(new GlobalizationSection())
        {
        }

        public GlobalizationSectionNode(GlobalizationSection data)
            :base(data)
        {
        }

        protected override void InitializeProperties(IPropertyAttributeService propertyAttributeService)
        {
            base.InitializeProperties(propertyAttributeService);

            propertyAttributeService.AddAttributeForProperty(typeof(GlobalizationSection), "UICulture", new TypeAttribute(typeof(CultureInfo), typeof(CultureInfoStringConverter)));
            propertyAttributeService.AddAttributeForProperty(typeof(GlobalizationSection), "Culture", new TypeAttribute(typeof(CultureInfo), typeof(CultureInfoStringConverter)));
            
            propertyAttributeService.AddAttributeForProperty(typeof(GlobalizationSection), "ResourceProviderFactoryType", new EditorAttribute(typeof(StringTypeSelectorEditor), typeof(UITypeEditor)));
            propertyAttributeService.AddAttributeForProperty(typeof(GlobalizationSection), "ResourceProviderFactoryType", new BaseTypeAttribute(typeof(ResourceProviderFactory)));
        }
    }
}
