using System;
using System.Collections.Generic;
using System.Text;
using System.Web.Configuration;
using EnterpriseLibraryExtensions.NakedNode;
using Microsoft.Practices.EnterpriseLibrary.Configuration.Design;
using System.ComponentModel;
using System.Drawing.Design;

namespace EnterpriseLibraryExtensions.SystemWeb
{
    [SelectedImage(typeof(IdentitySectionNode))]
    [Image(typeof(IdentitySectionNode))]
    public class IdentitySectionNode : NakedConfigurationNode<IdentitySection>
    {
        public IdentitySectionNode()
            : this(new IdentitySection())
        {
        }

        public IdentitySectionNode(IdentitySection data)
            :base(data)
        {
        }

        protected override void InitializeProperties(IPropertyAttributeService propertyAttributeService)
        {
            propertyAttributeService.SetDefaultAttributes(typeof(PasswordProperty));

            propertyAttributeService.AddAttributeForProperty(typeof(IdentitySection), "Password", new BrowsableAttribute(false));
            base.InitializeProperties(propertyAttributeService);
        }

        protected override void AddUnionedObjects()
        {
            base.AddUnionedObject("_password", new PasswordProperty(TheObject));
        }


        private class PasswordProperty
        {
            Password _password;
            IdentitySection _identitySection;
            public PasswordProperty(IdentitySection identitySection)
            {
                _identitySection = identitySection;
                _password = new Password(_identitySection.Password);
            }

            public Password Password
            {
                get { return _password; }
                set
                {
                    _password = value;
                    _identitySection.Password = _password.Value;
                }
            }
        }
    }
}
