using System;
using System.Collections.Generic;
using System.Text;
using System.ComponentModel.Design;
using EnterpriseLibraryExtensions.NakedNode;
using Microsoft.Practices.EnterpriseLibrary.Configuration.Design;
using System.Diagnostics;

namespace EnterpriseLibraryExtensions.SystemWeb
{
    public class MsdnHyperlinkVerb : IConfigDesignerVerb
    {
        #region IConfigDesignerVerb Members

        public List<DesignerVerb> VerbsForCofigurationNode(ConfigurationNode o)
        {
            NakedConfigurationNode nakedNode = o as NakedConfigurationNode;
            if (nakedNode != null && nakedNode.TheObject.GetType().Namespace.StartsWith("System"))
                return new List<DesignerVerb>(new DesignerVerb[] { new VerbContainer(nakedNode.TheObject).TheVerb }); ;

            return new List<DesignerVerb>();
        }

        

        #endregion

        private class VerbContainer
        {
            object o;
            DesignerVerb _verb;

            public VerbContainer(object o)
            {
                this.o = o;
                _verb = new DesignerVerb("Documentation on MSDN", new EventHandler(this.DoExecute));
            }

            public void DoExecute(object sender, EventArgs args)
            {
                string linkOnMsdn = string.Format("http://msdn2.microsoft.com/en-us/library/{0}_properties(VS.80).aspx", o.GetType().FullName);

                try
                {
                    Process ieLauncher = new Process();
                    ieLauncher.StartInfo.FileName = "iexplore.exe";
                    ieLauncher.StartInfo.Arguments = linkOnMsdn;

                    ieLauncher.Start();
                }
                catch
                {
                }
            }


            public DesignerVerb TheVerb
            {
                get
                {
                    return _verb;
                }
            }

        }
    }
}
