using System;
using System.Collections.Generic;
using System.Text;
using EnterpriseLibraryExtensions.NakedNode;
using System.Web.Configuration;
using Microsoft.Practices.EnterpriseLibrary.Configuration.Design;
using System.ComponentModel;

namespace EnterpriseLibraryExtensions.SystemWeb
{
    [SelectedImage(typeof(NamespaceCollectionNode))]
    [Image(typeof(NamespaceCollectionNode))]
    public class NamespaceCollectionNode : NakedConfigurationNodeCollection<NamespaceCollection, NamespaceCollectionNode.RWNamespace>
    {
        public NamespaceCollectionNode()
        {
        }

        public NamespaceCollectionNode(NamespaceCollection data)
            :base(data, data.EmitClear)
        {
            foreach (NamespaceInfo ns in data)
            {
                AddCollectionItem(new RWNamespace(ns));
            }
        }

        public override void Validate(IList<Microsoft.Practices.EnterpriseLibrary.Configuration.Design.Validation.ValidationError> errors)
        {
            //TODO
            base.Validate(errors);
        }


        public override void CopyTo(object target)
        {
            NamespaceCollection namespaceCollection = target as NamespaceCollection;
            
            if (namespaceCollection != null)
            {
                namespaceCollection.Clear();
                foreach (RWNamespace namespaceItem in Collection)
                {
                    namespaceCollection.Add(namespaceItem.CreateElement());
                }
                namespaceCollection.EmitClear = EmitClear;
            }
        }



        public class RWNamespace : CollectionItem<NamespaceInfo>
        {
            public RWNamespace()
            {
            }

            public RWNamespace(NamespaceInfo namespaceInfo)
                : base(namespaceInfo)
            {
            }

            public override NamespaceInfo CreateElement()
            {
                return new NamespaceInfo((string)base["name"]); 
            }
        }
    }
}
