using System;
using System.Collections.Generic;
using System.Text;
using System.Web.Configuration;
using Microsoft.Practices.EnterpriseLibrary.Configuration.Design;
using EnterpriseLibraryExtensions.NakedNode;
using System.ComponentModel;
using System.Drawing.Design;
using System.Web.UI;

namespace EnterpriseLibraryExtensions.SystemWeb
{
    [SelectedImage(typeof(PagesSection))]
    [Image(typeof(PagesSection))]
    public class PagesSectionNode : NakedConfigurationNode<PagesSection>
    {
        public PagesSectionNode()
            : this(new PagesSection())
        {
        }

        public PagesSectionNode(PagesSection data)
            :base(data)
        {
            
        }

        protected override void InitializeProperties(IPropertyAttributeService propertyAttributeService)
        {
            propertyAttributeService.AddAttributeForProperty(typeof(PagesSection), "PageBaseType", new EditorAttribute(typeof(StringTypeSelectorEditor), typeof(UITypeEditor)));
            propertyAttributeService.AddAttributeForProperty(typeof(PagesSection), "PageBaseType", new BaseTypeAttribute(typeof(Page), TypeSelectorIncludes.BaseType));
            propertyAttributeService.AddAttributeForProperty(typeof(PagesSection), "PageBaseType", new DefaultAssemblyStringAttribute("System.Web, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a"));

            propertyAttributeService.AddAttributeForProperty(typeof(PagesSection), "UserControlBaseType", new EditorAttribute(typeof(StringTypeSelectorEditor), typeof(UITypeEditor)));
            propertyAttributeService.AddAttributeForProperty(typeof(PagesSection), "UserControlBaseType", new BaseTypeAttribute(typeof(UserControl), TypeSelectorIncludes.BaseType));
            propertyAttributeService.AddAttributeForProperty(typeof(PagesSection), "UserControlBaseType", new DefaultAssemblyStringAttribute("System.Web, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a"));

            propertyAttributeService.AddAttributeForProperty(typeof(PagesSection), "PageParserFilterType", new EditorAttribute(typeof(StringTypeSelectorEditor), typeof(UITypeEditor)));
            propertyAttributeService.AddAttributeForProperty(typeof(PagesSection), "PageParserFilterType", new BaseTypeAttribute(typeof(PageParserFilter), TypeSelectorIncludes.BaseType));
            propertyAttributeService.AddAttributeForProperty(typeof(PagesSection), "PageParserFilterType", new DefaultAssemblyStringAttribute("System.Web, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a"));

            base.InitializeProperties(propertyAttributeService);
        }
    }
}
