using System;
using System.Collections.Generic;
using System.Text;
using EnterpriseLibraryExtensions.NakedNode;
using System.Web.Configuration;
using Microsoft.Practices.EnterpriseLibrary.Configuration.Design;
using System.ComponentModel;

namespace EnterpriseLibraryExtensions.SystemWeb
{
    [SelectedImage(typeof(ProfilePropertySettingsCollectionNode))]
    [Image(typeof(ProfilePropertySettingsCollectionNode))]
    public class ProfilePropertySettingsCollectionNode : NakedConfigurationNodeCollection<ProfilePropertySettingsCollection, ProfilePropertySettingsCollectionNode.RWPropertySettings>
    {
        public ProfilePropertySettingsCollectionNode()
        {
        }

        public ProfilePropertySettingsCollectionNode(ProfilePropertySettingsCollection data)
            : base(data, data.EmitClear)
        {
            foreach (ProfilePropertySettings settings in data)
            {
                AddCollectionItem(new RWPropertySettings(settings));
            }
        }

        public override void Validate(IList<Microsoft.Practices.EnterpriseLibrary.Configuration.Design.Validation.ValidationError> errors)
        {
            //TODO
            base.Validate(errors);
        }

        protected override void AddUnionedObjects()
        {
            base.AddUnionedObject("_name", new NameProperty(this));
        }

        public override void CopyTo(object target)
        {
            ProfilePropertySettingsCollection profilePropertySettingsCollection = target as ProfilePropertySettingsCollection;

            if (profilePropertySettingsCollection != null)
            {
                profilePropertySettingsCollection.Clear();
                foreach (RWPropertySettings propertySetting in Collection)
                {
                    profilePropertySettingsCollection.Add(propertySetting.CreateElement());
                }
                
                //foreach (ProfilePropertySettingsCollectionNode propertyCollectionNode in Nodes)
                //{
                //    ProfileGroupSettings groupSettings = new ProfileGroupSettings(propertyCollectionNode.Name);
                //    propertyCollectionNode.CopyTo(groupSettings.PropertySettings);

                //    profilePropertySettingsCollection..GroupSettings.Add(groupSettings);
                //}

                profilePropertySettingsCollection.EmitClear = EmitClear;
            }
        }

        private class NameProperty
        {
            ConfigurationNode _node;
            public NameProperty(ConfigurationNode node)
            {
                _node = node;
            }

            [Category("(name)")]
            public string Name
            {
                get { return _node.Name; }
                set { _node.Name = value; }
            }
        }

        public class RWPropertySettings : CollectionItem<ProfilePropertySettings>
        {
            public RWPropertySettings()
            {
            }

            public RWPropertySettings(ProfilePropertySettings profilePropertySettings)
                : base(profilePropertySettings)
            {
            }

            public override ProfilePropertySettings CreateElement()
            {
                return new ProfilePropertySettings((string)base["name"], (bool)base["readOnly"], (SerializationMode)base["serializeAs"], (string)base["provider"], (string)base["defaultValue"], (string)base["type"], (bool)base["allowAnonymous"], (string)base["customProviderData"]);
            }
        }
    }
}
