using System;
using System.Collections.Generic;
using System.Text;
using EnterpriseLibraryExtensions.NakedNode;
using System.Web.Configuration;
using Microsoft.Practices.EnterpriseLibrary.Configuration.Design;
using System.ComponentModel;

namespace EnterpriseLibraryExtensions.SystemWeb
{
    [SelectedImage(typeof(ProfileSettingsCollectionNode))]
    [Image(typeof(ProfileSettingsCollectionNode))]
    public class ProfileSettingsCollectionNode : NakedConfigurationNodeCollection<ProfileSettingsCollection, ProfileSettingsCollectionNode.RWProfileSettings>
    {
        public ProfileSettingsCollectionNode()
        {
        }

        public ProfileSettingsCollectionNode(ProfileSettingsCollection data)
            : base(data, data.EmitClear)
        {
            foreach (ProfileSettings profileSetting in data)
            {
                AddCollectionItem(new RWProfileSettings(profileSetting));
            }
        }

        public override void Validate(IList<Microsoft.Practices.EnterpriseLibrary.Configuration.Design.Validation.ValidationError> errors)
        {
            //TODO
            base.Validate(errors);
        }


        public override void CopyTo(object target)
        {
            ProfileSettingsCollection profileSettings = target as ProfileSettingsCollection;

            if (profileSettings != null)
            {
                profileSettings.Clear();
                foreach (RWProfileSettings profileSetting in Collection)
                {
                    profileSettings.Add(profileSetting.CreateElement());
                }
                
                foreach(ProfilePropertySettingsCollectionNode propertyCollectionNode in Nodes)
                {
                    //profileSettings..Add(propertyCollectionNode.TheObject);
                }

                profileSettings.EmitClear = EmitClear;
            }
        }



        public class RWProfileSettings : CollectionItem<ProfileSettings>
        {
            public RWProfileSettings()
            {
            }

            public RWProfileSettings(ProfileSettings profileSettings)
                : base(profileSettings)
            {
            }

            public override ProfileSettings CreateElement()
            {
                return new ProfileSettings((string)base["name"], (int) base["minInstances"], (int) base["maxLimit"], (TimeSpan) base["minInterval"], (string) base["custom"]);
            }
        }
    }
}
