using System;
using System.Collections.Generic;
using System.Text;
using System.ComponentModel;
using Microsoft.Practices.EnterpriseLibrary.Configuration.Design;
using System.Configuration;

namespace EnterpriseLibraryExtensions.SystemWeb
{
    public class ProviderElementCollectionTypeConverter :StringConverter 
    {
        public override bool GetStandardValuesExclusive(ITypeDescriptorContext context)
        {
            return false;
        }

        public override bool GetStandardValuesSupported(ITypeDescriptorContext context)
        {
            return true;
        }

        public override TypeConverter.StandardValuesCollection GetStandardValues(ITypeDescriptorContext context)
        {
            List<string> providerNames = new List<string>();
            
            ConfigurationNode contextNode = context.Instance as ConfigurationNode;
            if (contextNode != null)
            {
                ProviderSettingsCollectionNode settingsNode = contextNode.Hierarchy.FindNodeByType(contextNode, typeof(ProviderSettingsCollectionNode)) as ProviderSettingsCollectionNode;
                if (settingsNode != null)
                {
                    foreach (RWProviderSettings provider in settingsNode.Collection)
                    {
                        providerNames.Add(provider.Name);
                    }
                }
            }

            return new StandardValuesCollection(providerNames);
        }
    }
}
