using System;
using System.Collections.Generic;
using System.Text;
using EnterpriseLibraryExtensions.NakedNode;
using System.Web.Configuration;
using Microsoft.Practices.EnterpriseLibrary.Configuration.Design;
using System.ComponentModel;

namespace EnterpriseLibraryExtensions.SystemWeb
{
    [SelectedImage(typeof(RuleSettingsCollectionNode))]
    [Image(typeof(RuleSettingsCollectionNode))]
    public class RuleSettingsCollectionNode : NakedConfigurationNodeCollection<RuleSettingsCollection, RuleSettingsCollectionNode.RWRuleSettings>
    {
        public RuleSettingsCollectionNode()
        {
        }

        public RuleSettingsCollectionNode(RuleSettingsCollection data)
            : base(data, data.EmitClear)
        {
            foreach (RuleSettings ruleSetting in data)
            {
                AddCollectionItem(new RWRuleSettings(ruleSetting));
            }
        }

        public override void Validate(IList<Microsoft.Practices.EnterpriseLibrary.Configuration.Design.Validation.ValidationError> errors)
        {
            //TODO
            base.Validate(errors);
        }


        public override void CopyTo(object target)
        {
            RuleSettingsCollection ruleSettings = target as RuleSettingsCollection;

            if (ruleSettings != null)
            {
                ruleSettings.Clear();
                foreach (RWRuleSettings ruleSetting in Collection)
                {
                    ruleSettings.Add(ruleSetting.CreateElement());
                }
                ruleSettings.EmitClear = EmitClear;
            }
        }



        public class RWRuleSettings : CollectionItem<RuleSettings>
        {
            public RWRuleSettings()
            {
            }

            public RWRuleSettings(RuleSettings ruleSettings)
                : base(ruleSettings)
            {
            }

            public override RuleSettings CreateElement()
            {
                return new RuleSettings((string)base["name"], (string)base["eventName"], (string)base["provider"], (string) base["profile"], (int) base["minInstances"], (int) base["maxLimit"], (TimeSpan) base["minInterval"], (string) base["custom"]);
            }
        }
    }
}
