using System;
using System.Collections.Generic;
using System.Text;
using EnterpriseLibraryExtensions.NakedNode;
using System.Web.Configuration;
using Microsoft.Practices.EnterpriseLibrary.Configuration.Design;
using System.Web.Services.Configuration;

namespace EnterpriseLibraryExtensions.SystemWeb
{
    [Image(typeof(SystemWebSectionGroupNode))]
    [SelectedImage(typeof(SystemWebSectionGroupNode))]
    public class SystemWebSectionGroupNode : NakedConfigurationNode<SystemWebSectionGroup>
    {
        public SystemWebSectionGroupNode()
            : this(new SystemWebSectionGroup())
        {
        }
        public SystemWebSectionGroupNode(SystemWebSectionGroup sysWebGroup)
            :base(sysWebGroup)
        {
            Rename("SystemWeb setting");
        }

        protected override void InitializeCommands(NakedNodeCommandRegistrar commandRegistrar)
        {
            commandRegistrar.DisableResigtration(typeof(WebServicesSection));
            commandRegistrar.DisableResigtration(typeof(WebPartsSection));
            commandRegistrar.DisableResigtration(typeof(AuthorizationSection));
            commandRegistrar.DisableResigtration(typeof(WebControlsSection));
            base.InitializeCommands(commandRegistrar);
        }
    }
}
