using System;
using System.Collections.Generic;
using System.Text;
using EnterpriseLibraryExtensions.NakedNode;
using System.Web.Configuration;
using Microsoft.Practices.EnterpriseLibrary.Configuration.Design;
using System.ComponentModel;
using System.Drawing.Design;

namespace EnterpriseLibraryExtensions.SystemWeb
{
    [SelectedImage(typeof(TagMapCollectionNode))]
    [Image(typeof(TagMapCollectionNode))]
    public class TagMapCollectionNode : NakedConfigurationNodeCollection<TagMapCollection, TagMapCollectionNode.RWTagMap>
    {
        public TagMapCollectionNode()
        {
        }

        public TagMapCollectionNode(TagMapCollection data)
            :base(data, data.EmitClear)
        {
            foreach (TagMapInfo tm in data)
            {
                AddCollectionItem(new RWTagMap(tm));
            }
        }

        public override void Validate(IList<Microsoft.Practices.EnterpriseLibrary.Configuration.Design.Validation.ValidationError> errors)
        {
            //TODO
            base.Validate(errors);
        }

        protected override void InitializeProperties(IPropertyAttributeService propertyAttributeService)
        {
            propertyAttributeService.AddAttributeForProperty(typeof(TagMapInfo), "TagType", new EditorAttribute(typeof(StringTypeSelectorEditor), typeof(UITypeEditor)));
            propertyAttributeService.AddAttributeForProperty(typeof(TagMapInfo), "TagType", new BaseTypeAttribute(typeof(System.Web.UI.Control)));

            propertyAttributeService.AddAttributeForProperty(typeof(TagMapInfo), "MappedTagType", new EditorAttribute(typeof(StringTypeSelectorEditor), typeof(UITypeEditor)));
            propertyAttributeService.AddAttributeForProperty(typeof(TagMapInfo), "MappedTagType", new BaseTypeAttribute(typeof(System.Web.UI.Control)));
            
            base.InitializeProperties(propertyAttributeService);
        }


        public override void CopyTo(object target)
        {
            TagMapCollection TagMapCollection = target as TagMapCollection;
            
            if (TagMapCollection != null)
            {
                TagMapCollection.Clear();
                foreach (RWTagMap tagMap in Collection)
                {
                    TagMapCollection.Add(tagMap.CreateElement());
                }
                TagMapCollection.EmitClear = EmitClear;
            }
        }



        public class RWTagMap : CollectionItem<TagMapInfo>
        {
            public RWTagMap()
            {
            }

            public RWTagMap(TagMapInfo tagMap)
                :base(tagMap)
            {
            }

            public override TagMapInfo CreateElement()
            {
                return new TagMapInfo((string)base["tagTypeName"], (string)base["mappedTagTypeName"]);
            }
        }
    }
}
