using System;
using System.Collections.Generic;
using System.Text;
using EnterpriseLibraryExtensions.NakedNode;
using System.Web.Configuration;
using Microsoft.Practices.EnterpriseLibrary.Configuration.Design;
using System.ComponentModel;

namespace EnterpriseLibraryExtensions.SystemWeb
{
    [SelectedImage(typeof(TagPrefixCollectionNode))]
    [Image(typeof(TagPrefixCollectionNode))]
    public class TagPrefixCollectionNode : NakedConfigurationNodeCollection<TagPrefixCollection, TagPrefixCollectionNode.RWTagPrefix>
    {
        public TagPrefixCollectionNode()
        {
        }

        public TagPrefixCollectionNode(TagPrefixCollection data)
            : base(data, data.EmitClear)
        {
            foreach (TagPrefixInfo tp in data)
            {
                AddCollectionItem(new RWTagPrefix(tp));
            }
        }

        public override void Validate(IList<Microsoft.Practices.EnterpriseLibrary.Configuration.Design.Validation.ValidationError> errors)
        {
            //TODO
            base.Validate(errors);
        }


        public override void CopyTo(object target)
        {
            TagPrefixCollection tagPrefixCollection = target as TagPrefixCollection;
            if (tagPrefixCollection != null)
            {
                tagPrefixCollection.Clear();
            
                foreach (RWTagPrefix tagPrefix in Collection)
                {
                    tagPrefixCollection.Add(tagPrefix.CreateElement());
                }
                tagPrefixCollection.EmitClear = EmitClear;
            }
        }

        public class RWTagPrefix : CollectionItem<TagPrefixInfo>
        {
            public RWTagPrefix()
            {
            }

            public RWTagPrefix(TagPrefixInfo tagprefix)
                :base(tagprefix)
            {

            }

            public override TagPrefixInfo CreateElement()
            {
                return new TagPrefixInfo((string)base["tagPrefix"], (string)base["namespace"], (string)base["assembly"], (string)base["tagName"], (string)base["source"]);
            }
        }
    }
}