using System;
using System.Collections.Generic;
using System.Text;
using EnterpriseLibraryExtensions.NakedNode;
using System.Web.Configuration;
using Microsoft.Practices.EnterpriseLibrary.Configuration.Design;
using System.ComponentModel;
using EnterpriseLibraryExtensions.EnvironmentalOverrides;
using Microsoft.Practices.EnterpriseLibrary.Configuration.Design.Validation;

namespace EnterpriseLibraryExtensions.SystemWeb
{
    [SelectedImage(typeof(TrustLevelCollectionNode))]
    [Image(typeof(TrustLevelCollectionNode))]
    public class TrustLevelCollectionNode : NakedConfigurationNodeCollection<TrustLevelCollection, TrustLevelCollectionNode.RWTrustLevel>
    {
        public TrustLevelCollectionNode()
            : this(new TrustLevelCollection())
        {
        }

        public TrustLevelCollectionNode(TrustLevelCollection data)
            : base(data, data.EmitClear, false)
        {

            foreach (TrustLevel tl in data)
            {
                AddCollectionItem(new RWTrustLevel(tl));
            }
        }

        public override void CopyTo(object target)
        {
            TrustLevelCollection trustLevelCollection = target as TrustLevelCollection;
            if (trustLevelCollection == null) return;

            trustLevelCollection.Clear();
            foreach (RWTrustLevel trustLevel in Collection)
            {
                trustLevelCollection.Add(trustLevel.CreateElement());
            }
            trustLevelCollection.EmitClear = EmitClear;
        }

        public class RWTrustLevel : CollectionItem<TrustLevel>
        {
            public RWTrustLevel()
            {
            }

            public RWTrustLevel(TrustLevel trustLevel)
                : base(trustLevel)
            {
            }

            public override TrustLevel CreateElement()
            {
                return new TrustLevel((string)base["name"], (string)base["policyFile"]);
            }
        }
    }


}
