using System;
using System.Collections.Generic;
using System.Text;
using System.Reflection;

namespace EnterpriseLibraryExtensions
{
    public class DesignerVerbLoader
    {
        private static bool DesignVerbsLoaded = false;
        private static object LoadDesigVerbsLock = new object();

        public static void DoLoad(IServiceProvider serviceProvider)
        {
			if (!DesignVerbsLoaded)
				lock(LoadDesigVerbsLock)
					if (!DesignVerbsLoaded)
					{
						IConfigDesignerVerbCollection designerVerbCollection = (IConfigDesignerVerbCollection) serviceProvider.GetService(typeof(IConfigDesignerVerbCollection));
						foreach(Assembly asm in AppDomain.CurrentDomain.GetAssemblies())
						{
							foreach(ConfigDesignVerbExportAttribute expertAttribute in asm.GetCustomAttributes(typeof(ConfigDesignVerbExportAttribute), true))
							{
								IConfigDesignerVerb designVerb = Activator.CreateInstance(expertAttribute.ConfigDesignVerb) as IConfigDesignerVerb;
								if (designVerb != null && designerVerbCollection != null)
								{
									designerVerbCollection.Add(designVerb);
								}
							}
						}
						DesignVerbsLoaded = true;
					}
        }
    }
}
