using System;
using System.Collections.Generic;
using System.Text;

namespace EnterpriseLibraryExtensions.EnvironmentalOverrides
{
    [AttributeUsage(AttributeTargets.Property, AllowMultiple=true)]
    public sealed class EnvironmentalOverridePropertyAttribute: Attribute
    {
        private readonly bool _canOverride = true;

        public EnvironmentalOverridePropertyAttribute(bool canOverride)
        {
            _canOverride = canOverride;
        }

        public bool CanOverride
        {
            get { return _canOverride; }
        }
    }
}
