using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using System.ComponentModel.Design;

namespace EnterpriseLibraryExtensions
{
    class HostService : IHostService
    {
        public static void RegisterService(IServiceProvider serviceProvider)
        {
            if (serviceProvider.GetService(typeof(IHostService)) == null)
            {
                IServiceContainer serviceContainer = serviceProvider.GetService(typeof(IServiceContainer)) as IServiceContainer;
                if (serviceContainer != null)
                {
                    IHostService hostService = new HostService();
                    serviceContainer.AddService(typeof(IHostService), hostService);
                }
            }
        }

        private static Host _host;
        static HostService()
        {
            if (Application.ExecutablePath.EndsWith("DevEnv.Exe", StringComparison.OrdinalIgnoreCase))
            {
                _host = Host.VisualStudio;
            }
            else
            {
                _host = Host.Console;
            }
        }

        public Host CurrentHost
        {
            get { return _host; }
        }
    }

    public interface IHostService
    {
        Host CurrentHost { get; }
    }

    public enum Host
    {
        VisualStudio,
        Console
    }
}
