using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Practices.EnterpriseLibrary.Configuration.Design;
using System.Drawing;

namespace EnterpriseLibraryExtensions
{
    [AttributeUsage(AttributeTargets.Class, AllowMultiple=false)]
    public sealed class NodeInformationAttribute : Attribute
    {
        private readonly string _resourceKeyHtml;
        private readonly string _resourceKeyTitle;
        private readonly Type _imageType;
        private readonly Type _resourceType;

        public NodeInformationAttribute(Type imageType, string resourceKeyHtml, string resourceKeyTitle, Type resourceType)
        {
            _imageType = imageType;
            _resourceKeyHtml = resourceKeyHtml;
            _resourceType = resourceType;
            _resourceKeyTitle = resourceKeyTitle;
        }

        public string Html
        {
            get
            {
                return ResourceStringLoader.LoadString(_resourceType.FullName, _resourceKeyHtml, _resourceType.Assembly);
            }
        }

        public string Title
        {
            get
            {
                return ResourceStringLoader.LoadString(_resourceType.FullName, _resourceKeyTitle, _resourceType.Assembly);
            }
        }

        public Type IconType
        {
            get { return _imageType; }
        }
    }
}
